//Tested under Ubuntu 16.04 Opencv 2.4.13
//Compile with command: g++ MT9V034_demo.cpp -o Test `pkg-config --cflags --libs opencv` -lArduCamLib -L. -I.
//This demo is only demonstrate how to use the Arducam SDK functions, 
//the performance is not good, need to create capture and display two thread to get best performance.

#include <opencv2/opencv.hpp>
#include "ArduCamLib.h"
#include <iostream>

using namespace std;
using namespace cv;

Mat BytestoMat(Uint8* bytes,int width,int height)
{
    Mat image = Mat(height,width,CV_8UC1,bytes);
    return image;
}

ArduCamHandle useHandle;
ArduCamCfg useCfg;
Uint32 pUsbIdxArray[10];

int main(int argc, char** argv )
{
		unsigned int u32Value = 0xFFFFFFFF;
		bool open_flag = 0;
    Uint8* pu8FrameData;
    int number = 0;
	  int i ;
	  Mat image;
	  
	  
	  //ArduCam_autoopen( useHandle, &useCfg ); 
	  number = ArduCam_scan( pUsbIdxArray, 0x52cb );
	  cout << "Device found = " << number << " \n";
	  
	  
	  useCfg.u16Vid = 0x52cb;
    useCfg.u32Width = 640;
    useCfg.u32Height = 480;
    useCfg.u8PixelBytes = 1;
    useCfg.u8PixelBits = 8;
    useCfg.emI2cMode = I2C_MODE_8_16;
    useCfg.u32SensorShipAddr = 0x90;
    
    //1. Open the camera to get the handle
    u32Value = ArduCam_autoopen( useHandle, &useCfg );
     //u32Value = ArduCam_open( useHandle, &useCfg, 0 );

    if (u32Value == 0)
    {
        open_flag = 1;
        cout << "ArduCam_open successful\n" ;
    }
    else
    {
        open_flag = 0;
        cout << "ArduCam_open failed\n" ;
    }

		//2. Call beginCapture to start a capture task
    ArduCam_beginCapture(useHandle);

    while(open_flag == 1)
    {
	    
	    //3. Catpure a new frame
	    ArduCam_capture(useHandle);
	    //4. Check if there is any available to read
	    if ( ArduCam_availiable(useHandle) > 0)
	    {
	        cout << "frame available\n";
	        //5. Read a frame
	        ArduCam_read(useHandle, pu8FrameData );
	        
	        //6. Display the frame
	        image = BytestoMat(pu8FrameData, 640, 480);
	        if ( !image.data )
			    {
			        cout << "No image data \n";
			        //return -1;
			    }
			    //cout << image.data[100] << image.data[101] << "\n";
			    namedWindow("Display Image", WINDOW_AUTOSIZE );
			    imshow("Display Image", image);
			    cvWaitKey(1);
	        //7. Delete the old frame
	        ArduCam_del(useHandle);
	        cout << "Delete frame \n";
	    }

    }
    //8. Call endCapture to delete the capture task
    ArduCam_endCapture(useHandle );
    //9. Delete the camera handle
    ArduCam_del(useHandle);
      
}



